<ngx-loading [show]="loading" />

<div [ngClass]="[jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <div [ngClass]="[jds.d('flex'), jds.mb(25)]">
      <h5>Unduh Indikator</h5>
    </div>

    <form
      class="form"
      [formGroup]="myForm"
      (ngSubmit)="onFilter()"
      (keydown.enter)="$event.stopPropagation()"
    >
      <div [ngClass]="jds.row">
        <div [ngClass]="jds.col(5)">
          <label [ngClass]="jds.formLabel">
            Klasifikasi <span [ngClass]="jds.text('danger')">*</span>
          </label>
          <ng-select
            class="select-tags"
            [items]="indicatorClassificationData$ | async"
            [multiple]="true"
            placeholder="Pilih Klasifikasi"
            bindValue="name"
            bindLabel="name"
            formControlName="classification"
          />
          <ng-container
            *ngIf="
              f.classification?.invalid &&
              (f.classification?.dirty || f.classification?.touched)
            "
          >
            <div
              *ngIf="f.classification?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
          </ng-container>
        </div>
        <div [ngClass]="jds.col(6)">
          <label [ngClass]="jds.formLabel">Organisasi</label>
          <ng-select
            class="select-tags"
            #organizationSelect
            [items]="organizationData$ | async"
            [multiple]="true"
            bindLabel="nama_skpd"
            bindValue="kode_skpd"
            placeholder="Pilih Organisasi"
            formControlName="kode_skpd"
          />
          <ng-container
            *ngIf="
              f.kode_skpd?.invalid &&
              (f.kode_skpd?.dirty || f.kode_skpd?.touched)
            "
          >
            <div
              *ngIf="f.kode_skpd?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
          </ng-container>
        </div>
        <div
          [ngClass]="jds.col(1)"
          [style.alignSelf]="'flex-end'"
        >
          <button
            [ngClass]="[jds.button, jds.buttonPrimary]"
            [disabled]="!myForm.valid"
            type="submit"
          >
            Filter
          </button>
        </div>
      </div>
    </form>

    <div
      *ngIf="indicatorIsLoadingList$ | async"
      [ngClass]="jds.mt(20)"
    >
      <div
        class="wrapper-skeleton"
        *ngFor="let number of [100, 100, 100, 100]"
      >
        <ngx-skeleton-loader
          [theme]="{
            width: number + '%',
            'border-radius': '0',
            height: '20px',
            'margin-bottom': '10px'
          }"
        />
      </div>
    </div>

    <div
      *ngIf="(indicatorIsLoadingList$ | async) === false"
      [ngClass]="jds.mt(20)"
    >
      <ng-container *ngIf="indicatorData?.length > 0">
        <div [ngClass]="[jds.d('flex'), jds.justifyContent('end'), jds.mb(20)]">
          <jds-bi-hosted-dropdown
            [(open)]="isDropdown"
            [jdsBiDropdownLimitWidth]="'auto'"
            [jdsBiDropdownAlign]="'right'"
            [content]="dropdown"
          >
            <button
              [ngClass]="[jds.button, jds.buttonPrimary, jds.d('flex')]"
              type="button"
            >
              <span>Unduh </span>
              <jds-bi-icon
                [ngClass]="[jds.ms(8)]"
                name="chevron-down"
              />
            </button>
          </jds-bi-hosted-dropdown>

          <ng-template #dropdown>
            <ul
              [ngClass]="[jds.dropdownMenu]"
              [style.minWidth.px]="150"
            >
              <li [ngClass]="[jds.dropdownNavbarItem]">
                <a
                  [ngClass]="[jds.dropdownNavbarLink]"
                  (click)="onDownload('csv')"
                >
                  CSV
                </a>
              </li>
              <li [ngClass]="[jds.dropdownNavbarItem]">
                <a
                  [ngClass]="[jds.dropdownNavbarLink]"
                  (click)="onDownload('excel')"
                >
                  Excel
                </a>
              </li>
            </ul>
          </ng-template>
        </div>

        <div [ngClass]="[jds.card]">
          <div [ngClass]="[jds.tableResponsive]">
            <table
              [ngClass]="[jds.table]"
              role="table"
              aria-label="Indicator Catalog"
              aria-describedby="Table Indicator Catalog"
            >
              <thead>
                <tr>
                  <th
                    [style.width.%]="5"
                    [ngClass]="jds.textAlign('center')"
                    scope="col"
                  >
                    <input
                      id="checkbox_indicator"
                      [ngClass]="[jds.formCheckInput]"
                      [checked]="true"
                      (click)="checkCheckedAll($event.target.checked)"
                      type="checkbox"
                      value="all"
                    />
                  </th>
                  <th scope="col">Nama Indikator</th>
                  <th
                    [style.width.%]="30"
                    scope="col"
                  >
                    Organisasi
                  </th>
                  <th
                    [style.width.%]="30"
                    scope="col"
                  >
                    Klasifikasi
                  </th>
                </tr>
              </thead>
              <tbody>
                <tr *ngFor="let row of indicatorData; let i = index">
                  <td [ngClass]="jds.textAlign('center')">
                    <input
                      id="checkbox_indicator{{ i }}"
                      [ngClass]="[jds.formCheckInput]"
                      [checked]="row.checked"
                      [value]="row.id"
                      (click)="filterIndicator($event.target.checked, row)"
                      type="checkbox"
                    />
                  </td>
                  <td>{{ row.name }}</td>
                  <td>{{ row.nama_skpd }}</td>
                  <td>
                    <ng-container *ngFor="let class of row.history_class">
                      <span
                        [colorScheme]="getClassificationColor(class.id_class)"
                        [ngClass]="[jds.me(8)]"
                        jdsBiBadge
                      >
                        {{ class.name }}
                      </span>
                    </ng-container>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </ng-container>

      <ng-container *ngIf="indicatorData?.length === 0">
        <app-list-empty type="dataset">
          <h6>Belum ada indikator yang dipilih.</h6>
          <p>
            Silahkan lengkapi filter berdasarkan klasifikasi dan organisasi
            untuk menampilkan indikator.
          </p>
        </app-list-empty>
      </ng-container>
    </div>
  </div>
</div>

<!-- Modal Download -->
<app-modal
  id="modal-download-indicator-bulk"
  #modal
  [isClose]="false"
  position="center"
>
  <ng-container ngProjectAs="body">
    <div [ngClass]="[jds.mt(10), jds.mb(10)]">
      <h6>Unduh Indikator</h6>
      <div [ngClass]="[jds.d('flex'), jds.mb(8)]">
        Proses pengaksesan indikator
        <span [ngClass]="jds.ms('auto')">{{ downloadProgress }}%</span>
      </div>
      <div [ngClass]="jds.progress">
        <div
          [ngClass]="[
            jds.progressBar,
            jds.progressBarStriped,
            jds.progressBarAnimated,
            jds.bg('success')
          ]"
          [style.width.%]="downloadProgress"
          role="progressbar"
          aria-label="Unduh Indikator"
        ></div>
      </div>
    </div>
  </ng-container>
</app-modal>
